# Python development course, based around this code

All this will move into a sister project to actually teach this approach. See [Add Teaching repository](https://github.com/cruisen/cli-calc/issues/17).

# Learn Python
* Zen of Python [PEP020](https://www.python.org/dev/peps/pep-0020/)
* Learn and master Python with [exercism.org](https://exercism.org/tracks/python)

# OOO

> “I’m sorry that I long ago coined the term “objects” for this topic because it gets many people to focus on the lesser idea. The big idea is messaging.”
~ Alan Kay

From:
* [The forgotten History of OOP](https://medium.com/javascript-scene/the-forgotten-history-of-oop-88d71b9b2d9f)
* [Does It Mean You Are Doing Object-Oriented Programming If You Write Classes?](https://igorfil.com/posts/oop-meaning/)

## Code Smells
* [Get a Whiff of This by Sandi Metz (Talk)](https://www.youtube.com/watch?v=PJjHfa5yxlU)
  * [Smells to Refactorings (pdf)](https://people.scs.carleton.ca/~jeanpier/Fall2021/Topic%204-%20About%20Smells%20and%20Refactoring/1a-%20Smells%20to%20Refactorings.pdf) 
    Quick Reference Guide
* [99 Bottles of OOP by Sandi Metz (Book)](https://sandimetz.com/99bottles)

## Refactoring
* [All the Little Things by Sandi Metz (Talk)](https://www.youtube.com/watch?v=8bZh5LMaSmE)
  * [Succession by Katrina Owen (Talk)](https://www.youtube.com/watch?v=59YClXmkCVM)
  * [Succession by Katrina Owen (git)](https://github.com/kytrinyx/succession)
* [Polly Want a Message by Sandi Metz (Talk)](https://www.youtube.com/watch?v=YtROlyWWhV0)

## SOLID
* [SOLID Object-Oriented Design by Sandi Metz (Talk)](https://www.youtube.com/watch?v=v-2yFMzxqwU)
* [SOLID (Wikipedia)](https://en.wikipedia.org/wiki/SOLID)
* [SOLID Design Principles simplified with UML](https://medium.com/@RikamPalkar/solid-design-principles-simplified-with-uml-8432a3406248)

## Design Patterns
* [Design Patterns for Python](https://refactoring.guru/design-patterns/python)
  * [Design Patterns](https://en.wikipedia.org/wiki/Design_Patterns)

## OO, Class & Message
* [OO](https://en.wikipedia.org/wiki/Object-oriented_programming)
  * [UML Class Diagram Tutorial](https://www.visual-paradigm.com/guide/uml-unified-modeling-language/uml-class-diagram-tutorial/)
* [Messaging](https://www.quora.com/Why-is-object-oriented-programming-more-about-messaging-than-objects)


# Manifests
Following these rules, which basically reduce our possibilities, 
we enable ourselves to write maintainable software. They build upon each other.
* [Design Patterns](https://en.wikipedia.org/wiki/Design_Patterns)
* [Manifesto for Agile Software Development](https://agilemanifesto.org/)
* [Manifesto for Software Craftsmanship](https://manifesto.softwarecraftsmanship.org/)
  * [Software Craftsmanship (Wikipedia)](https://en.wikipedia.org/wiki/Software_craftsmanship)
   

# Time to burn
* [Six Impossible Things by Kevlin Henney (Talk)](https://www.youtube.com/watch?v=YoaZzIZFErI)
* [How to succeed in language design without really trying by Brian Kernighan (Talk)](https://www.youtube.com/watch?v=Sg4U4r_AgJU)

